﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using Resources.Context;

#nullable disable

namespace Resources.Migrations
{
    [DbContext(typeof(DtContext))]
    [Migration("20230522173410_AddScheduleToBuilding")]
    partial class AddScheduleToBuilding
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.5")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("Models.Building", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("Address")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("City")
                        .HasColumnType("text");

                    b.Property<string>("Description")
                        .HasColumnType("text");

                    b.Property<string>("ImageId")
                        .HasColumnType("text");

                    b.Property<string>("InstructionsString")
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("RoundId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("ScheduleString")
                        .HasColumnType("text");

                    b.Property<string>("Zip")
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("ImageId");

                    b.HasIndex("RoundId");

                    b.ToTable("Buildings");
                });

            modelBuilder.Entity("Models.BuildingInstruction", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("BuildingId")
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("BuildingId");

                    b.ToTable("BuildingInstructions");
                });

            modelBuilder.Entity("Models.BuildingTask", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("BuildingId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("BuildingId");

                    b.ToTable("BuildingTasks");
                });

            modelBuilder.Entity("Models.BuildingTaskSession", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<DateTime?>("CompletedAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("RoundSessionId")
                        .HasColumnType("text");

                    b.Property<DateTime?>("StartedAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("TaskId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("RoundSessionId");

                    b.HasIndex("TaskId");

                    b.ToTable("BuildingTaskSessions");
                });

            modelBuilder.Entity("Models.Image", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<DateTime?>("ExpiresAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("OriginalUrl")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("ThumbnailUrl")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("UploaderId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("UploaderId");

                    b.ToTable("Images");
                });

            modelBuilder.Entity("Models.Region", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.ToTable("Regions");
                });

            modelBuilder.Entity("Models.Round", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("RegionId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("RegionId");

                    b.ToTable("Rounds");
                });

            modelBuilder.Entity("Models.RoundSession", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<DateTime?>("CompletedAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("RoundId")
                        .HasColumnType("text");

                    b.Property<string>("RoundSnapshotId")
                        .HasColumnType("text");

                    b.Property<DateTime?>("StartedAt")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("RoundId");

                    b.HasIndex("RoundSnapshotId")
                        .IsUnique();

                    b.HasIndex("UserId");

                    b.ToTable("RoundSession");
                });

            modelBuilder.Entity("Models.RoundSnapshot", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("Data")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("Hash")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("RoundId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("RoundSessionId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTime>("SnapShotAt")
                        .HasColumnType("timestamp with time zone");

                    b.HasKey("Id");

                    b.HasIndex("RoundId");

                    b.ToTable("RoundSnapshots");
                });

            modelBuilder.Entity("Models.Session", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("AccessToken")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("DeviceFingerprint")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<DateTime>("Expires")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("RefreshToken")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("text");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("AuthSessions");
                });

            modelBuilder.Entity("Models.User", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text");

                    b.Property<string>("Email")
                        .HasColumnType("text");

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("LastName")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<string>("PhoneNumber")
                        .IsRequired()
                        .HasColumnType("text");

                    b.Property<int>("Role")
                        .HasColumnType("integer");

                    b.HasKey("Id");

                    b.ToTable("Users");
                });

            modelBuilder.Entity("RegionUser", b =>
                {
                    b.Property<string>("RegionsId")
                        .HasColumnType("text");

                    b.Property<string>("UsersId")
                        .HasColumnType("text");

                    b.HasKey("RegionsId", "UsersId");

                    b.HasIndex("UsersId");

                    b.ToTable("RegionUser");
                });

            modelBuilder.Entity("RoundUser", b =>
                {
                    b.Property<string>("AssignedUsersId")
                        .HasColumnType("text");

                    b.Property<string>("RoundsId")
                        .HasColumnType("text");

                    b.HasKey("AssignedUsersId", "RoundsId");

                    b.HasIndex("RoundsId");

                    b.ToTable("RoundUser");
                });

            modelBuilder.Entity("Models.Building", b =>
                {
                    b.HasOne("Models.Image", "Image")
                        .WithMany()
                        .HasForeignKey("ImageId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Models.Round", "Round")
                        .WithMany("Buildings")
                        .HasForeignKey("RoundId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Image");

                    b.Navigation("Round");
                });

            modelBuilder.Entity("Models.BuildingInstruction", b =>
                {
                    b.HasOne("Models.Building", "Building")
                        .WithMany("Instructions")
                        .HasForeignKey("BuildingId");

                    b.Navigation("Building");
                });

            modelBuilder.Entity("Models.BuildingTask", b =>
                {
                    b.HasOne("Models.Building", "Building")
                        .WithMany("Tasks")
                        .HasForeignKey("BuildingId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Building");
                });

            modelBuilder.Entity("Models.BuildingTaskSession", b =>
                {
                    b.HasOne("Models.RoundSession", null)
                        .WithMany("Tasks")
                        .HasForeignKey("RoundSessionId");

                    b.HasOne("Models.BuildingTask", "Task")
                        .WithMany("TaskSessions")
                        .HasForeignKey("TaskId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Task");
                });

            modelBuilder.Entity("Models.Image", b =>
                {
                    b.HasOne("Models.User", "Uploader")
                        .WithMany("UploadedImages")
                        .HasForeignKey("UploaderId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Uploader");
                });

            modelBuilder.Entity("Models.Round", b =>
                {
                    b.HasOne("Models.Region", "Region")
                        .WithMany("Rounds")
                        .HasForeignKey("RegionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Region");
                });

            modelBuilder.Entity("Models.RoundSession", b =>
                {
                    b.HasOne("Models.Round", "Round")
                        .WithMany("Sessions")
                        .HasForeignKey("RoundId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Models.RoundSnapshot", "RoundSnapshot")
                        .WithOne("RoundSession")
                        .HasForeignKey("Models.RoundSession", "RoundSnapshotId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("Models.User", "User")
                        .WithMany("RoundSessions")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Round");

                    b.Navigation("RoundSnapshot");

                    b.Navigation("User");
                });

            modelBuilder.Entity("Models.RoundSnapshot", b =>
                {
                    b.HasOne("Models.Round", "Round")
                        .WithMany("Snapshots")
                        .HasForeignKey("RoundId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.Navigation("Round");
                });

            modelBuilder.Entity("Models.Session", b =>
                {
                    b.HasOne("Models.User", "User")
                        .WithMany("Sessions")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("User");
                });

            modelBuilder.Entity("RegionUser", b =>
                {
                    b.HasOne("Models.Region", null)
                        .WithMany()
                        .HasForeignKey("RegionsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Models.User", null)
                        .WithMany()
                        .HasForeignKey("UsersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("RoundUser", b =>
                {
                    b.HasOne("Models.User", null)
                        .WithMany()
                        .HasForeignKey("AssignedUsersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Models.Round", null)
                        .WithMany()
                        .HasForeignKey("RoundsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Models.Building", b =>
                {
                    b.Navigation("Instructions");

                    b.Navigation("Tasks");
                });

            modelBuilder.Entity("Models.BuildingTask", b =>
                {
                    b.Navigation("TaskSessions");
                });

            modelBuilder.Entity("Models.Region", b =>
                {
                    b.Navigation("Rounds");
                });

            modelBuilder.Entity("Models.Round", b =>
                {
                    b.Navigation("Buildings");

                    b.Navigation("Sessions");

                    b.Navigation("Snapshots");
                });

            modelBuilder.Entity("Models.RoundSession", b =>
                {
                    b.Navigation("Tasks");
                });

            modelBuilder.Entity("Models.RoundSnapshot", b =>
                {
                    b.Navigation("RoundSession")
                        .IsRequired();
                });

            modelBuilder.Entity("Models.User", b =>
                {
                    b.Navigation("RoundSessions");

                    b.Navigation("Sessions");

                    b.Navigation("UploadedImages");
                });
#pragma warning restore 612, 618
        }
    }
}
